/*
 * EfficientExcessTrustParametricBoostrapSampler.h
 *
 *  Created on: Dec 20, 2011
 *      Author: duyvu
 */

#ifndef EFFICIENTEXCESSTRUSTPARAMETRICBOOSTRAPSAMPLER_H_
#define EFFICIENTEXCESSTRUSTPARAMETRICBOOSTRAPSAMPLER_H_

#include "ExcessTrustParametricBoostrapSampler.h"

namespace mixderg {

class EfficientExcessTrustParametricBoostrapSampler: public mixderg::ExcessTrustParametricBoostrapSampler {
protected:
	EdgeSet currentNonzeroGraph;
	void moreInitialization();
	int generateDyadicValue(unsigned int k, unsigned int l, int *& dyad_ij,
			EdgeList & Y, unsigned int i, unsigned int j);
	void generateSelfBlock(unsigned int k, EdgeList& Y,
			unsigned int kStartIndex, unsigned int kN);
	void generateCrossBlock(unsigned int k, unsigned int l, EdgeList& Y,
			unsigned int kStartIndex, unsigned int kN,
			unsigned int lStartIndex, unsigned int lN);
public:
	EfficientExcessTrustParametricBoostrapSampler();
	virtual ~EfficientExcessTrustParametricBoostrapSampler();

	void normalizeDyadProbs();
	void generateSample(EdgeList& Y, UnsignedIntVector& Z);
};

}

#endif /* EFFICIENTEXCESSTRUSTPARAMETRICBOOSTRAPSAMPLER_H_ */
