/*
 * ExcessTrustParametricBoostrapSampler.h
 *
 *  Created on: Dec 20, 2011
 *      Author: duyvu
 */

#ifndef EXCESSTRUSTPARAMETRICBOOSTRAPSAMPLER_H_
#define EXCESSTRUSTPARAMETRICBOOSTRAPSAMPLER_H_

#include "var/ParametricBoostrapSampler.h"

namespace mixderg {

class ExcessTrustParametricBoostrapSampler: public mixderg::ParametricBoostrapSampler {
protected:
	// Theta paramters
	DoubleVector excessTrustTheta;
	double negDenTheta, negRecTheta, posRecTheta;

	virtual void moreInitialization();
public:
	ExcessTrustParametricBoostrapSampler();
	virtual ~ExcessTrustParametricBoostrapSampler();

	void setParameters(const char* modelFilename, const char* delim);
	void generateSample(EdgeList& Y, UnsignedIntVector& Z);
	void printModel2File(ofstream & modelFile);

	void initializeModelParameters();
};

}

#endif /* EXCESSTRUSTPARAMETRICBOOSTRAPSAMPLER_H_ */
